﻿package{
	import flash.display.*;
	import flash.events.Event;
	import flash.filters.BlurFilter;
	import flash.geom.Matrix;
	import flash.geom.Point;
	import flash.events.MouseEvent;

	public class Perliner extends Sprite
	{
		private var bmd:BitmapData;
		private var background:Bitmap;
		private var angle:Number = 0;
		private var painter:Sprite;
		private var matrix:Matrix ;
		private var color:int = Math.random()*0xff0000;
		private var alfa: Number = .5;
		private var filterObj:BlurFilter = new BlurFilter(4,4,1);
		
		public function Perliner():void
		{
			addEventListener(Event.ADDED_TO_STAGE,addedHandler);
			addEventListener(MouseEvent.MOUSE_DOWN, mouseHandler);
		}
		private function addedHandler(e:Event):void
		{
			bmd = new BitmapData(stage.stageWidth,stage.stageHeight,false,0xff000000);
			background = new Bitmap(bmd);
			addChild(background);
			painter = new Sprite();
			init();
			addEventListener(Event.ENTER_FRAME,enterHandler);
		}
		private function mouseHandler(e:MouseEvent):void{
			//trace("CLICK");
			angle = 0;
		}
		private function init():void
		{
			angle = 0;
			//painter.graphics.beginFill(color,alfa);
			painter.graphics.lineStyle(10, 0xffffff);
			painter.graphics.drawRoundRect(0,0,20,80,50,50);
			painter.graphics.drawRoundRect(-30,30,80,20,50,50);
					}
		private function enterHandler(e:Event):void
		{
			if(angle<100){
				matrix = new Matrix();
				matrix.translate(angle,mouseX);
				matrix.rotate(-angle);
				bmd.applyFilter(bmd,bmd.rect,new Point(0,0),filterObj);
				bmd.draw(painter,matrix);
				angle--;
			}else{
				init();
			}
		}
	}
}